#pragma once

#include <QDialog>
#include "qxtglobalshortcut.h"

#include "config.h"

namespace Ui {
	class ButtonSearch;
}

class ButtonSearch : public QDialog {
	Q_OBJECT

public:
	explicit ButtonSearch(const Config& config, QWidget *parent = nullptr);
	ButtonSearch(const ButtonSearch&) = delete; // no copy
	~ButtonSearch();

protected:
	void buttonPressed(int i);

private slots:
	void closeSearch();

	void selectionDown();
	void selectionUp();

private:
	const Config& config;
	Ui::ButtonSearch *ui;

	static const uint8_t NUMCOUNT = 46;
	QxtGlobalShortcut* esc;
	QxtGlobalShortcut* enter;
	QxtGlobalShortcut* up;
	QxtGlobalShortcut* down;
	QxtGlobalShortcut* nums[NUMCOUNT];
};
